#include <stdio.h>
#include <stdlib.h>
#if UNIX
#include <time.h>
#endif
#include "nano-X.h"
/*
 * font demo for Nano-X
 */

#define MAXW 		630
#define MAXH 		470

#if HAVE_T1LIB_SUPPORT
#define FONT1 "bchr"
#define FONT2 "bchb"
#define FONT3 "dcr10"
#define FONT4 "dcbx10"
#define FONT5 "bchri"
#else
#define FONT1 "fonts/lt1-r-omega-serif.ttf"
#define FONT2 "/tmp/times.ttf"
#define FONT3 "/tmp/cour.ttf"
#define FONT4 "/tmp/tempsitc.ttf"
#define FONT5 "/tmp/calist.ttf"
#endif

#define MAXFONTS 5
static char * names[MAXFONTS] = { FONT1, FONT2, FONT3, FONT4, FONT5 };

int main()
{
	GR_WINDOW_ID 	window;
	GR_EVENT 	event;
        GR_GC_ID 	gc;
	GR_FONTID	fontid;
        int 		i, x, y;
   
        srand(time(0));
   
        GrOpen();
	window = GrNewWindow(GR_ROOT_WINDOW_ID, 5, 5, MAXW, MAXH, 4, BLACK, BLUE);
	GrMapWindow(window);

   
        gc = GrNewGC();

        GrSelectEvents(window,GR_EVENT_MASK_ALL);
        GrSetGCUseBackground(gc,FALSE);
	GrSetGCBackground(gc, RGB(0, 0, 0));
	while(1) {
	      GrCheckNextEvent(&event);
	   
	      i = (int)((float)MAXFONTS * rand() / (RAND_MAX + 1.0));
	      fontid = GrCreateFont(names[i], 20);
  	      GrSetGCFont(gc, fontid);
	      GrSetGCFontSize(gc, 1 + (int) (80.0 * rand() / (RAND_MAX + 1.0)));
	      //GrSetGCBackground(gc, rand() & 0xffffff);
 	      GrSetGCForeground(gc, rand() & 0xffffff);
	      x = (int) ((MAXW * 1.0) *rand()/(RAND_MAX+1.0));
	      y = (int) ((MAXH * 1.0) *rand()/(RAND_MAX+1.0));

	      GrText(window, gc,x,y, "Microwindows", -1, TF_ASCII);

	      GrUnloadFont(fontid);
	}

	GrClose();
}
