/*
 * Copyright (c) 1999 Greg Haerr <greg@censoft.com>
 *
 * Screen Driver Utilities
 * 
 * MicroWindows Proportional Font Routine Header (proportional font format)
 *
 * These routines are screen driver entry points.
 */

#define NUMBER_FONTS	4	/* number of compiled-in fonts*/

/* entry points*/
BOOL	gen_getfontinfo(PMWFONT pfont, PFONTINFO pfontinfo);
void	gen_gettextsize(PMWFONT pfont, const void *text, int cc,
		COORD *pwidth, COORD *pheight, COORD *pbase);
void	gen_gettextbits(PMWFONT pfont, int ch, IMAGEBITS *retmap,
		COORD *pwidth, COORD *pheight, COORD *pbase);
void	gen_unloadfont(PMWFONT pfont);

void	corefont_drawtext(PMWFONT pfont, PSD psd, COORD x, COORD y,
		const void *text, int cc, int flags);

/* local data*/
extern MWCOREFONT gen_fonts[NUMBER_FONTS];

/* the following aren't used yet*/
void	gen_drawtext(PMWFONT pfont, PSD psd, COORD x, COORD y,
		const void *text, int n, PIXELVAL fg);
void 	gen_drawbitmap(PSD psd,COORD x,COORD y,COORD width,COORD height,
		IMAGEBITS *table, PIXELVAL fgcolor);
